/* Bas Aarts. ... The Slave .... */
#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <time.h>
#include "pvm3.h"
#include <signal.h>

#define randomize()	(srand((unsigned)(MyTid+time(NULL))))
#define random(num)     (rand()%(num))
#define Min(a, b)       (((a) < (b)) ? (a) : (b))
#define Max(a, b)       (((a) > (b)) ? (a) : (b))
#define FALSE           0
#define TRUE            1

#define M2S_INIT1	1
#define M2S_INIT2	2
#define M2S_SAVE	3
#define M2S_NOSYNC	4
#define M2S_DATA1	5
#define M2S_DATA2       6

#define S2M_KILL	11
#define S2M_END		12
#define S2M_SYNC	13
#define S2M_OPT		14

#define S2S_COPY	21

#define INTSIZE         sizeof(int)

#define ENCODING	PvmDataRaw
#define MAXFILENAMELEN	50
#define MAXINT		100000000

typedef char		Bool;
typedef int*		SchedType;

int N;
int M;
SchedType CurrentSchedule;
SchedType BestSchedule;
int BestScheduleSize;
int ScheduleSize;
int ScheduleLength;
int *sm;
int *sj;
int *pm;
int *pj;
int *d;
int *m;
int *r;
int *s;
int *FirstMachine;
int *LastMachine;
int *RLambda;
int *Mx;
int *PossRev; =
int *PossNr; =
int TabuRev;
int PropRev;
int BestMx;
int *TabuList;
int TabuLength;
SchedType *BackList;
int MaxBackNr;
int BackNr = 0; =

int MinCost = MAXINT;
int MaxIt;
int *BackIt;
int MaxItBackUp;
int It = 0;
int *t;
int StepIt;
int StoreBackUp;
Bool OptFound;

int ParentTid;
int MyTid;
int HostNumber;
int SyncTime;
Bool StartSync;

void StartSynchronize() {
  StartSync = TRUE;
}

int BackSort(const void *a, const void *b) {
  return (*(SchedType*)b)[2] - (*(SchedType*)a)[2];
}

void Synchronize() {
  int i, j, Tag;

  pvm_initsend(ENCODING);
  pvm_pkint(&HostNumber, 1, 1);
  pvm_pkint(&BackNr, 1, 1);
  for (i = BackNr; i;) pvm_pkint(&BackList[--i][2], 1, 1);
  pvm_send(ParentTid, S2M_SYNC);

    /* wacht op master*/
  pvm_bufinfo(pvm_recv(ParentTid, -1), (int*) 0, &Tag, (int*) 0);

  if (Tag == M2S_DATA1) {
    int Waste, Send;
    pvm_upkint(&Waste, 1, 1);
    pvm_upkint(&Send, 1, 1);

    if (Waste) {
      for (i = 0, BackNr -= Waste; i < BackNr; i++) {
	SchedType Temp = BackList[i];
	BackList[i] = BackList[i+Waste];
        BackList[i+Waste] = Temp;
      }
      StoreBackUp -= Waste;
    }
      /* Verzenden of ontvangen van schedules */
    if (Send > 0) {
        /* Verzend Schedules */  =

      for (i = 0; i < Send; i++) {
        pvm_recv(ParentTid, M2S_DATA2);
        pvm_upkint(&j, 1, 1);
        pvm_initsend(ENCODING);
        pvm_pkint(BackList[i], ScheduleLength, 1);
        pvm_send(j, S2S_COPY);
      }
      for (i = 0, BackNr -=Send ; i < BackNr; i++) {
        SchedType Temp = BackList[i];
        BackList[i] = BackList[i+Send];
        BackList[i+Send] = Temp;
      }
      StoreBackUp -= Send;
    } =

    else if (Send < 0) {
	/* Ontvangen van schedules */
      for (i = Send; i; i++) {
        pvm_recv(-1, S2S_COPY);
        pvm_upkint(BackList[BackNr++], ScheduleLength, 1);
      }
      qsort(BackList, BackNr, sizeof(SchedType), BackSort);
      if (BackList[BackNr-1][2] < MinCost) {
        MinCost = BackList[BackNr-1][2];
	memcpy(BestSchedule, &BackList[BackNr-1][3], BestScheduleSize);
	StoreBackUp = BackNr;
      }
      else StoreBackUp -= Send;
    }
      /* Zet alarm voor volgende synchronisatie */
    alarm(SyncTime);
  }
  StartSync = FALSE;
}

void RANDOM(int v1) {
  int i, k;
  randomize();
  for (i = 0; i < M; i++) LastMachine[i] = N;
  for (i = 0; i < v1; i++) t[i] = M*i;
  do {
    k = t[i = random(v1)];
    t[i] = t[--v1];
    if (LastMachine[m[k]] == N) FirstMachine[m[k]] = k;
    else sm[LastMachine[m[k]]] = k;
    pm[k] = LastMachine[m[k]];
    pj[k] = k%M ? k-1 : N;
    if ((sj[k] = (k%M == M-1) ? N+1 : k+1) != N+1) t[v1++] = sj=[k];
    LastMachine[m[k]] = k ;
  } while (v1);
  for (i = 0; i < M; i++) sm[LastMachine[i]] = N+1;
}

void Init_D(void) {
    /* VARIABELE VOOR TABUSEARCH */
  int J;
    /* Aantal jobs in een schedule */

    /* TELLERTJE */
  int i;

   /* Voor unieke random initialisatie */
  MyTid = pvm_mytid();

    /* Zet optie voor routering */
  pvm_setopt(PvmRoute, PvmRouteDirect);

    /* Ontvangen en decoderen van data van de master */
  pvm_recv(ParentTid = pvm_parent(), M2S_INIT1);
  pvm_upkint(&HostNumber, 1, 1);

  pvm_recv(ParentTid, M2S_INIT2);
  pvm_upkint(&M, 1, 1);
  pvm_upkint(&J, 1, 1);
  m = (int*) calloc(N = J*M, INTSIZE);
  d = (int*) calloc(N+1, INTSIZE);
  pvm_upkint(m, N, 1);
  pvm_upkint(d, N, 1);
  pvm_upkint(&MaxBackNr, 1, 1);
  pvm_upkint(&MaxIt, 1, 1);
  pvm_upkint(&StepIt, 1, 1);
  pvm_upkint(&SyncTime, 1, 1);

  sj = (int*) calloc(N+1, INTSIZE); sj[N] = N;
  pj = (int*) calloc(N+2, INTSIZE); pj[N+1] = N+1;
    /* pj[N] wordt nooit geadresseerd */

    /* geheugen reserveren voor schedule */
  ScheduleSize = (ScheduleLength = 4*N+2*M+7)*INTSIZE;
  CurrentSchedule = (SchedType) malloc(ScheduleSize+INTSIZE);
  BestSchedule = (SchedType) malloc(BestScheduleSize = (2*N+1)*INTSIZE);

  i = 0;
  PossNr       = &CurrentSchedule[i]; i++;
  BackIt       = &CurrentSchedule[i]; i++;
  RLambda      = &CurrentSchedule[i]; i++;
  sm           = &CurrentSchedule[i]; sm[N] = N; i += N+1;
  pm           = &CurrentSchedule[i]; pm[N] = N; pm[N+1] = N+1; i +=
= N+2;
  FirstMachine = &CurrentSchedule[i]; i += M;
  LastMachine  = &CurrentSchedule[i]; i += M;
  TabuList     = &CurrentSchedule[i]; i += N+1;
  PossRev      = &CurrentSchedule[i]; PossRev[N] = N;

  s = (int*) calloc(N+1, INTSIZE);
    /* s[N] wordt nooit geadresseerd alleen geinspecteerd */
  t = (int*) calloc(N, INTSIZE);
  r = (int*) calloc(N+2, INTSIZE);
    /* r[N+1] wordt nooit geadresseerd alleen geinspecteerd */
  Mx = (int*) calloc(N, INTSIZE);

    /* Geen enkele verwisseling is initieel tabu */
  for (i = 0, TabuList[N] = MAXINT; i < N; i++) TabuList[i] = -MAXI=
NT;

  BackList = (SchedType*) calloc(MaxBackNr, sizeof(SchedType));
  for (i = 0; i < MaxBackNr; i++)
    BackList[i]= (SchedType) malloc(ScheduleSize);
  *BackIt = 0;

  StartSync = OptFound = FALSE;

  MaxItBackUp = MaxIt;
  StepIt = MaxBackNr == 1 ? 0 : (MaxIt-StepIt)/(MaxBackNr-1);

    /* Construeer initiele schedule */
  RANDOM(J);

    /* Zet interrupt voor synchronisatie */
  signal(SIGALRM, StartSynchronize);
  alarm(SyncTime);
}

void Init_rt(void) {
  static int v1, a;
  Bool *in_v0 = (Bool*) calloc(N+2, sizeof(Bool));

  v1 = a = 0;
    /* V1 = t[0..v1) , V1 := {} */
  /* initialisatie van V1 en V0 uit het artikel*/
  for (in_v0[N+1] = TRUE; a < M; a++)
    if (sj[LastMachine[a]] > N)
      t[v1++] = LastMachine[a];
  /* {V0 = =ED} */
  /* einde initialisatie */

  do { /* "while V1 <> =ED" */
    in_v0[a = t[--v1]] = TRUE;
    /* "a: =EE V1" en "V1 := V1\{a}" en "V0 := V0 + {a}" */
    /* 0=F3a<N */
    r[a] = Max(r[sm[a]], r[sj[a]])+d[a];
    if (in_v0[sm[pj[a]]]) /*pj[a] <> N */
      t[v1++] = pj[a];
    if (in_v0[sj[pm[a]]]) /*pm[a] <> N */
      t[v1++] = pm[a];
  } while (v1);
  free(in_v0);
}

void Init_st(void) {
  static int v1, a;
  Bool *in_v0 = (Bool*) calloc(N+2, sizeof(Bool));

  v1 = a = 0;
    /* V1 = t[0..v1) , V1 := {} */
  /* initialisatie van V1 en V0 uit het artikel*/
  for (in_v0[N] = TRUE; a < M; a++)
    if (pj[FirstMachine[a]] == N)
      t[v1++] = FirstMachine[a];
  /* {V0 = =ED} */
  /* einde initialisatie */

  do { /* "while V1 <> =ED" */
    /* "a =EE V1" en "V1 := V1\{a}" en "V0 := V0 + {a}" */
    in_v0[a = t[--v1]] = TRUE;
    /* 0=F3a<N */
    s[a] = Max(s[pm[a]]+d[pm[a]], s[pj[a]]+d[pj[a]]);
    if (in_v0[pj[sm[a]]]) /*sm[a] <> N+1 */
      t[v1++] = sm[a];
    if (in_v0[pm[sj[a]]]) /*sj[a] <> N+1 */
      t[v1++] = sj[a];
  } while (v1);
  free(in_v0);
}

void Part_Init_rt(void) {
  static int v1, a;
  Bool *in_v0 = (Bool*) calloc(N+2, sizeof(Bool));

  v1 = 1;
  in_v0[*t = sm[PropRev]] = in_v0[N] = TRUE;
  do {
    if (!in_v0[pm[a = t[--v1]]]) in_v0[t[v1++] = pm[a]] = TRUE;
    if (!in_v0[pj[a]]) in_v0[t[v1++] = pj[a]] = TRUE;
  } while (v1);

  *t = sm[PropRev];
  v1 = 1;
  do { /* "while V1 <> =ED" */
    in_v0[a = t[--v1]] = FALSE;
    /* "a: =EE V1" en "V1 := V1\{a}" en "V0 := V0 + {a}" */
    /* 0=F3a<N */
    r[a] = Max(r[sm[a]], r[sj[a]])+d[a];
    if (!in_v0[sm[pj[a]]]) /*pj[a] <> N */
      t[v1++] = pj[a];
    if (!in_v0[sj[pm[a]]]) /*pm[a] <> N */
      t[v1++] = pm[a];
  } while (v1);
  free(in_v0);
}

void Part_Init_st(void) {
  static int v1, a;
  Bool *in_v0 = (Bool*) calloc(N+2, sizeof(Bool));

  v1 = 1;
  in_v0[*t = PropRev] = in_v0[N+1] = TRUE;
  do {
    if (!in_v0[sm[a = t[--v1]]]) in_v0[t[v1++] = sm[a]] = TRUE;
    if (!in_v0[sj[a]]) in_v0[t[v1++] = sj[a]] = TRUE;
  } while (v1);

  *t = PropRev;
  v1 = 1;
  do { /* "while V1 <> =ED" */
    /* "a =EE V1" en "V1 := V1\{a}" en "V0 := V0 + {a}"*/
    in_v0[a = t[--v1]] = FALSE;
    /* 0=F3a<N */
    s[a] = Max(s[pm[a]]+d[pm[a]], s[pj[a]]+d[pj[a]]);
    if (!in_v0[pj[sm[a]]])
      /*sm[a] <> N+1 */
      t[v1++] = sm[a];
    if (!in_v0[pm[sj[a]]])
      /*sj[a] <> N+1 */
      t[v1++] = sj[a];
  } while (v1);
  free(in_v0);
}

void Construct(void) {
  static int a;
  sm[a = pm[PropRev]] = sm[PropRev];
  pm[PropRev] = pm[a];
  if (pm[a] < N) sm[pm[a]] = PropRev;
  else FirstMachine[m[a]] = PropRev;
  if (sm[PropRev] < N) pm[sm[PropRev]] = a;
  else LastMachine[m[a]] = a;
  pm[sm[PropRev] = a] = PropRev;
  TabuList[PropRev] = (*BackIt)++;
  It++;
}

void Propose(void ) {
  int a = N+1, b = *PossNr = 0, c = TabuRev = N;
  static int stb, sta, rtb, rta, e;
  for (; b < M; b++)
    if (r[a] < r[FirstMachine[b]]) a = FirstMachine[b];
  *RLambda = r[a];
  e = (r[sm[a]] > r[sj[a]] ? sm : sj)[a];
  BestMx = MAXINT;
  PropRev = -1;
  do {
    e = (r[sm[b = e]] > r[sj[e]] ? sm : sj)[e];
    if (sm[a] == b && (c != pm[a] || sm[b] != e)) {
      if (TabuList[a]+TabuLength < *BackIt) {
	stb = s[pm[a]]+d[pm[a]] > s[pj[b]]+d[pj[b]] ?
	      s[pm[a]]+d[pm[a]] : s[pj[b]]+d[pj[b]];
	sta = stb+d[b] > s[pj[a]] + d[pj[a]] ?
	      stb+d[b] : s[pj[a]] + d[pj[a]];
        rta = (r[sj[a]] > r[sm[b]] ? r[sj[a]] : r[sm[b]])+d[a];
        rtb = (rta > r[sj[b]] ? rta : r[sj[b]])+d[b];
        if ((Mx[PossRev[*PossNr] = b] = =

             sta+rta > stb+rtb ? sta+rta : stb+rtb)
             < =

             BestMx) {
	  BestMx = Mx[b];
	  PropRev = *PossNr;
        }
      }
      else {
        Mx[PossRev[*PossNr] = b] = MAXINT;
        if (PropRev < 0 && TabuList[a] < TabuList[pm[PossRev[TabuRev]]])
          TabuRev = *PossNr;
      }
      (*PossNr)++;
    }
    c = a;
    a = b;
  } while (e < N);
}

int DesSort(const void *a, const void *b) {
  if (Mx[*(int*)a] < Mx[*(int*)b] ||
	(Mx[*(int*)a] == Mx[*(int*)b] &&
	 TabuList[pm[*(int*)a]] < TabuList[pm[*(int*)b]]
        )
     )
     return 1;
  else return -1;
}

void StoreSchedule(void) {
  if (BackNr == MaxBackNr) {
    SchedType Temp = *BackList;
    register int i = 1;
    for (;i < BackNr; i++) BackList[i-1] = BackList[i];
    BackList[i-1] = Temp;
  }
  else BackNr++;
  qsort(PossRev, *PossNr, INTSIZE, DesSort);
  memcpy(BackList[BackNr-1], CurrentSchedule, ScheduleSize);
}

Bool LoadSchedule(void) {
  if (BackNr) {
    static SchedType Temp;
    memcpy(CurrentSchedule, Temp = BackList[BackNr-1], ScheduleSize);
    if (TabuList[pm[PropRev = PossRev[--*Temp]]]+TabuLength
	>= *BackIt)
      *BackIt = TabuList[pm[PropRev]]+TabuLength+1;
    It = 0;
    Construct();
    MaxIt = MaxItBackUp-StepIt*(StoreBackUp-BackNr);
    if (!*Temp) BackNr--;
    return TRUE;
  }
  return FALSE;
}

void DoRev(void) {
  Propose();
  if (*PossNr) {
    static int q[50], i = 0, k = 0, j;
    if (PropRev < 0)
      *BackIt = TabuList[pm[PropRev = PossRev[j = TabuRev]]]+TabuLe=
ngth+1;
    else PropRev = PossRev[j = PropRev];

    if (q[i] <= ++q[*PossNr]) i = *PossNr;
    if (k == 0) {
      TabuLength = i+random(5);
      k = TabuLength+1;
    }
    else k--;

    if (*RLambda < MinCost) {
      if ((MinCost = *RLambda) < BestMx  && *PossNr > 1) {
	PossRev[j] = PossRev[--(*PossNr)];
	StoreSchedule();
      }
      memcpy(BestSchedule, sm, BestScheduleSize);
      StoreBackUp = BackNr;
      MaxIt = MaxItBackUp;
      It = 0;
    }
    Construct();
  }
  else {
      /* Optimum gevonden, stop berekening */
    OptFound = TRUE;
    BestSchedule = &CurrentSchedule[3];
    MinCost = *RLambda;
    It = MaxIt;
    BackNr = 0;
  }
}

int main () {
  Init_D();
  do {
    Init_rt();
    Init_st();
    while (It < MaxIt) {
      if (StartSync) Synchronize();
      DoRev();
      Part_Init_rt();
      Part_Init_st();
    }
  } while (LoadSchedule());
    /* Stuur het optimum naar de master */
  pvm_initsend(ENCODING);
  if (OptFound) {
    pvm_pkint(&MinCost, 1, 1);
    pvm_send(ParentTid, S2M_OPT);
  }
  else {
    pvm_pkint(&HostNumber, 1, 1);
    pvm_pkint(&MinCost, 1, 1);
    pvm_send(ParentTid, S2M_END);
  }

    /* Wacht op signaal van de master */
  pvm_recv(ParentTid, M2S_SAVE);

    /* Best gevonden schedule van allemaal */
  {
    char OutputFile[MAXFILENAMELEN];
    FILE *fp;
    int i;
    pvm_upkstr(OutputFile);
    fp = fopen(OutputFile, "a");
    fprintf(fp, "Cost : %d\n", MinCost);
    for ( i = 0; i < N; i++)
      fprintf(fp, "%6d   %6d   %6d\n",
		  i, BestSchedule[i+N+1], BestSchedule[i]);
    fprintf(fp,"\n");
    fclose(fp);
  }

  pvm_initsend(ENCODING);
  pvm_send(ParentTid, S2M_END);
  return 0;
}


